--Ultimate Randomizer Variables
--Made by Nightwolf

local urandom = {}
urandom.var = {} //Variables
urandom.cmds = {} //Commands
urandom.shufflearray = function(tab,size) 
	if not size then size = #tab end
	for i = size,1,-1 do
		local index = P_RandomRange(1,i)
		tab[i],tab[index] = $2,$1
	end
	return tab
end

//Main Variables
urandom.var.main = {}

//Character Randomizer Variables
urandom.var.charrandom = {
	isenabled = 0,
	crtime = 30, //Time between skin changes
	ultimate = 0, //Is ultimate on or off
	sa2random = 0, //Is SA2 Rando-like mode on or off
	timeoffset = 0, //Maximum crtime offset
	shownextskin = 0, //Show the next skin?
	showtimer = 1, //Show the timer?
}

urandom.var.objrandom = {
	isenabled = 0,
	setposition = 0, //0-none, 1-swap, 2-randomize
	randomtype = 0, //0-disable, 1-limited, 2-uniform, 3-smart, 4-full
	randomsize = 0, //0-disable, 1-50 to 200%, 2-12.5 to 500%
}

urandom.var.maprandom = {
	isenabled = 0,
	maps = {}, //Map list (global)
	bossmaps = 1, //Allow boss maps
	specialstages = 0, //Allow special stages
	autorandom = 1, //Automatic randomization
	mapnum = 1, //Current map number (in the map list, not SRB2 map number)
}

urandom.var.physrandom = {
	isenabled = 0,
	phtime = 30, //Time between physics changes
	speed = 1, //Speed randomization (0-off,1-limited,2-full)
	spindash = 0, //Spindash speed randomization (0-off,1-limited,2-full)
	friction = 0, //Friction randomization (0-off,1-limited,2-full)
	jumping = 0, //Jump height randomization (0-off,1-limited,2-full)
	actionspd = 0, //Action Speed randomization (0-off,1-limited,2-full)
	showtimer = 1, //Show the timer?
}

urandom.var.miscrandom = {
	texturerand = 0, //Wall Texture randomization (0-off,1-swap,2-randomize)
	flatrand = 0, //Flat randomization (0-off,1-swap,2-randomize)
	brightrand = 0, //Brightness randomization (0-off,1-relative,2-absolute)
	colorrand = 0, //Color randomization per map (0-off,1-on)
	abilityrand = 0, //Ability randomization per map (0-off,1-on)
}

rawset(_G,"_URANDOM",urandom)